;/*****************************************************************************
; * @file:    startup_LPC17xx.s
; * @purpose: CMSIS Cortex-M3 Core Device Startup File
; *           for the NXP LPC17xx Device Series
; * @version: V1.03
; * @date:    09. February 2010
; *----------------------------------------------------------------------------
; *
; * Copyright (C) 2010 ARM Limited. All rights reserved.
; *
; * ARM Limited (ARM) is supplying this software for use with Cortex-Mx
; * processor based microcontrollers.  This file can be freely distributed
; * within development tools that are supporting such ARM based processors.
; *
; * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
; * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
; * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
; * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
; * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
; *
; ******************************************************************************/


;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__vector_table" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version
;
.intvec:	section	.text

	xref	__stack
        xref  __stext
        xref  _SystemInit

	xref     _SVC_Handler
        xref     _PendSV_Handler
        xref     _SysTick_Handler

	xdef  __vector_table
        xdef  __vector_table_0x1c
        xdef  __Vectors
        xdef  __Vectors_End
        xdef  __Vectors_Size

        xdef     _NMI_Handler
        xdef     _HardFault_Handler
        xdef     _MemManage_Handler
        xdef     _BusFault_Handler
        xdef     _UsageFault_Handler

        xdef     _DebugMon_Handler

        xdef     _WDT_IRQHandler            ; 16: Watchdog Timer
        xdef     _TIMER0_IRQHandler         ; 17: Timer0
        xdef     _TIMER1_IRQHandler         ; 18: Timer1
        xdef     _TIMER2_IRQHandler         ; 19: Timer2
        xdef     _TIMER3_IRQHandler         ; 20: Timer3
        xdef     _UART0_IRQHandler          ; 21: UART0
        xdef     _UART1_IRQHandler          ; 22: UART1
        xdef     _UART2_IRQHandler          ; 23: UART2
        xdef     _UART3_IRQHandler          ; 24: UART3
        xdef     _PWM1_IRQHandler           ; 25: PWM1
        xdef     _I2C0_IRQHandler           ; 26: I2C0
        xdef     _I2C1_IRQHandler           ; 27: I2C1
        xdef     _I2C2_IRQHandler           ; 28: I2C2
        xdef     _SPI_IRQHandler            ; 29: SPI
        xdef     _SSP0_IRQHandler           ; 30: SSP0
        xdef     _SSP1_IRQHandler           ; 31: SSP1
        xdef     _PLL0_IRQHandler           ; 32: PLL0 Lock (Main PLL)
        xdef     _RTC_IRQHandler            ; 33: Real Time Clock
        xdef     _EINT0_IRQHandler          ; 34: External Interrupt 0
        xdef     _EINT1_IRQHandler          ; 35: External Interrupt 1
        xdef     _EINT2_IRQHandler          ; 36: External Interrupt 2
        xdef     _EINT3_IRQHandler          ; 37: External Interrupt 3
        xdef     _ADC_IRQHandler            ; 38: A/D Converter
        xdef     _BOD_IRQHandler            ; 39: Brown-Out Detect
        xdef     _USB_IRQHandler            ; 40: USB
        xdef     _CAN_IRQHandler            ; 41: CAN
        xdef     _DMA_IRQHandler            ; 42: General Purpose DMA
        xdef     _I2S_IRQHandler            ; 43: I2S
        xdef     _ENET_IRQHandler           ; 44: Ethernet
        xdef     _RIT_IRQHandler            ; 45: Repetitive Interrupt Timer
        xdef     _MCPWM_IRQHandler          ; 46: Motor Control PWM
        xdef     _QEI_IRQHandler            ; 47: Quadrature Encoder Interface
        xdef     _PLL1_IRQHandler           ; 48: PLL1 Lock (USB PLL)
        xdef	 _USBActivity_IRQHandler	  ; 49: USB Activity Interrupt
        xdef	 _CANActivity_IRQHandler	  ; 50: CAN Activity Interrupt

__vector_table:
        dc.l     __stack
        dc.l     _Reset_Handler+1

        dc.l     _NMI_Handler+1
        dc.l     _HardFault_Handler+1
        dc.l     _MemManage_Handler+1
        dc.l     _BusFault_Handler+1
        dc.l     _UsageFault_Handler+1
__vector_table_0x1c:
        dc.l     0
        dc.l     0
        dc.l     0
        dc.l     0
        dc.l     _SVC_Handler+1
        dc.l     _DebugMon_Handler+1
        dc.L     0
        dc.l     _PendSV_Handler+1
        dc.l     _SysTick_Handler+1

        ; External Interrupts
        dc.l     _WDT_IRQHandler+1            ; 16: Watchdog Timer
        dc.l     _TIMER0_IRQHandler+1         ; 17: Timer0
        dc.l     _TIMER1_IRQHandler+1         ; 18: Timer1
        dc.l     _TIMER2_IRQHandler+1         ; 19: Timer2
        dc.l     _TIMER3_IRQHandler+1         ; 20: Timer3
        dc.l     _UART0_IRQHandler+1          ; 21: UART0
        dc.l     _UART1_IRQHandler+1          ; 22: UART1
        dc.l     _UART2_IRQHandler+1          ; 23: UART2
        dc.l     _UART3_IRQHandler+1          ; 24: UART3
        dc.l     _PWM1_IRQHandler+1           ; 25: PWM1
        dc.l     _I2C0_IRQHandler+1           ; 26: I2C0
        dc.l     _I2C1_IRQHandler+1           ; 27: I2C1
        dc.l     _I2C2_IRQHandler+1           ; 28: I2C2
        dc.l     _SPI_IRQHandler+1            ; 29: SPI
        dc.l     _SSP0_IRQHandler+1           ; 30: SSP0
        dc.l     _SSP1_IRQHandler+1           ; 31: SSP1
        dc.l     _PLL0_IRQHandler+1           ; 32: PLL0 Lock (Main PLL)
        dc.l     _RTC_IRQHandler+1            ; 33: Real Time Clock
        dc.l     _EINT0_IRQHandler+1          ; 34: External Interrupt 0
        dc.l     _EINT1_IRQHandler+1          ; 35: External Interrupt 1
        dc.l     _EINT2_IRQHandler+1          ; 36: External Interrupt 2
        dc.l     _EINT3_IRQHandler+1          ; 37: External Interrupt 3
        dc.l     _ADC_IRQHandler+1            ; 38: A/D Converter
        dc.l     _BOD_IRQHandler+1            ; 39: Brown-Out Detect
        dc.l     _USB_IRQHandler+1            ; 40: USB
        dc.l     _CAN_IRQHandler+1            ; 41: CAN
        dc.l     _DMA_IRQHandler+1            ; 42: General Purpose DMA
        dc.l     _I2S_IRQHandler+1            ; 43: I2S
        dc.l     _ENET_IRQHandler+1           ; 44: Ethernet
        dc.l     _RIT_IRQHandler+1            ; 45: Repetitive Interrupt Timer
        dc.l     _MCPWM_IRQHandler+1          ; 46: Motor Control PWM
        dc.l     _QEI_IRQHandler+1            ; 47: Quadrature Encoder Interface
        dc.l     _PLL1_IRQHandler+1           ; 48: PLL1 Lock (USB PLL)
        dc.l	 _USBActivity_IRQHandler+1	  ; 49: USB Activity Interrupt
        dc.l	 _CANActivity_IRQHandler+1	  ; 50: CAN Activity Interrupt
__Vectors_End:

__Vectors:     		  EQU   __vector_table
__Vectors_Size: 	  EQU 	__Vectors_End - __Vectors


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Default interrupt handlers.
;;
        switch .text
_Reset_Handler:
        LDR     R0, =_SystemInit+1
        BLX     R0
        LDR     R0, =__stext+1
        BX      R0

_NMI_Handler:
        B _NMI_Handler

_HardFault_Handler:
	mrs	r0,PSP
	mrs	r1,MSP
STP:
	B	STP
        B _HardFault_Handler

_MemManage_Handler:
        B _MemManage_Handler

_BusFault_Handler:
        B _BusFault_Handler

_UsageFault_Handler:
        B _UsageFault_Handler

;_SVC_Handler:
;        B _SVC_Handler

_DebugMon_Handler:
        B _DebugMon_Handler

;_PendSV_Handler:
;        B _PendSV_Handler

;_SysTick_Handler:
;        B _SysTick_Handler

_WDT_IRQHandler:
        B _WDT_IRQHandler

_TIMER0_IRQHandler:
        B _TIMER0_IRQHandler

_TIMER1_IRQHandler:
        B _TIMER1_IRQHandler

_TIMER2_IRQHandler:
        B _TIMER2_IRQHandler

_TIMER3_IRQHandler:
        B _TIMER3_IRQHandler

_UART0_IRQHandler:
        B _UART0_IRQHandler

_UART1_IRQHandler:
        B _UART1_IRQHandler

_UART2_IRQHandler:
        B _UART2_IRQHandler

_UART3_IRQHandler:
        B _UART3_IRQHandler

_PWM1_IRQHandler:
        B _PWM1_IRQHandler

_I2C0_IRQHandler:
        B _I2C0_IRQHandler

_I2C1_IRQHandler:
        B _I2C1_IRQHandler

_I2C2_IRQHandler:
        B _I2C2_IRQHandler

_SPI_IRQHandler:
        B _SPI_IRQHandler

_SSP0_IRQHandler:
        B _SSP0_IRQHandler

_SSP1_IRQHandler:
        B _SSP1_IRQHandler

_PLL0_IRQHandler:
        B _PLL0_IRQHandler

_RTC_IRQHandler:
        B _RTC_IRQHandler

_EINT0_IRQHandler:
        B _EINT0_IRQHandler

_EINT1_IRQHandler:
        B _EINT1_IRQHandler

_EINT2_IRQHandler:
        B _EINT2_IRQHandler

_EINT3_IRQHandler:
        B _EINT3_IRQHandler

_ADC_IRQHandler:
        B _ADC_IRQHandler

_BOD_IRQHandler:
        B _BOD_IRQHandler

_USB_IRQHandler:
        B _USB_IRQHandler

_CAN_IRQHandler:
        B _CAN_IRQHandler

_DMA_IRQHandler:
        B _DMA_IRQHandler

_I2S_IRQHandler:
        B _I2S_IRQHandler

_ENET_IRQHandler:
        B _ENET_IRQHandler

_RIT_IRQHandler:
        B _RIT_IRQHandler

_MCPWM_IRQHandler:
        B _MCPWM_IRQHandler

_QEI_IRQHandler:
        B _QEI_IRQHandler

_PLL1_IRQHandler:
        B _PLL1_IRQHandler

_USBActivity_IRQHandler:
        B _USBActivity_IRQHandler

_CANActivity_IRQHandler:
        B _CANActivity_IRQHandler


#ifndef SRAM
.crp:	section .text
;/* Code Read Protection
;CRP1    0x12345678 - Write to RAM command can not access RAM below 0x10000200.
;                   - Read Memory command: disabled.
;                   - Copy RAM to Flash command: cannot write to Sector 0.
;                   - "Go" command: disabled.
;                   - Erase sector(s) command: can erase any individual sector except 
;                   	 sector 0 only, or can erase all sectors at once.
;                   - Compare command: disabled
;CRP2    0x87654321 - Write to RAM command: disabled.
;                   - Copy RAM to Flash: disabled.
;                   - Erase command: only allows erase of all sectors.
;CRP3    0x43218765 - Access to chip via the SWD pins is disabled. ISP entry
;                     by pulling PIO0_1 LOW is disabled if a valid user code is
;                     present in flash sector 0.
;Caution: If CRP3 is selected, no future factory testing can be
;performed on the device.
;*/
	dc.l	0xFFFFFFFF
#endif

        END
